MacDraft5Parser Class Referencefinal

the main class to read a MacDraft5 v4-v5 file More...

`#include <MacDraft5Parser.hxx>`

Inheritance diagram for MacDraft5Parser:

## Public Member Functions

| MacDraft5Parser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~MacDraft5Parser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGDrawingInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWGraphicParser
| ~MWAWGraphicParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions

void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGDrawingInterface *documentInterface)
| creates the listener which will be associated to the document
bool | send (MacDraft5ParserInternal::Image const &image)
| try to send all shapes in an image
bool | send (MacDraft5ParserInternal::Layout const &layout)
| try to send all shapes in an layout
bool | send (MacDraft5ParserInternal::Shape const &shape, MacDraft5ParserInternal::Layout const &layout, int depth=0)
| try to send a shape in a layout
bool | sendBitmap (MacDraft5ParserInternal::Shape const &bitmap, MWAWPosition const &position)
| try to send a bitmap
bool | sendText (int layoutId, long shapeId)
| try to send text with given id
bool | createZones ()
| finds the different objects zones
bool | readPrintInfo ()
| try to read the print info zone
bool | readDocHeader ()
| try to read the doc header zone ( mainly unknown )
bool | readDocFooter ()
| try to read last doc zone
bool | readLibraryHeader ()
| try to read the library header zone ( mainly unknown )
bool | readLibraryFooter ()
| try to read last library zone
bool | readObject (MacDraft5ParserInternal::Layout &layout)
| try to read an object
bool | readText (MacDraft5ParserInternal::Shape &shape)
| try to read the text data corresponding to a text shape
bool | readModifier (MacDraft5ParserInternal::Shape &shape)
| try to read a modifier
bool | readStringList ()
| try to read a list of strings
bool | readLayout (MacDraft5ParserInternal::Layout &layout)
| try to read the layout zone
bool | readLayoutDefinitions (MWAWEntry const &entry, bool inRsrc)
| try to read a LAYI:0 resource
bool | readLinks (MWAWEntry const &entry, bool inRsrc)
| try to read Link:128 resource
bool | readPICT (MWAWEntry const &entry, librevenge::RVNGBinaryData &pict)
| try to read a PICT entry (in data fork)
bool | readPICTList (MWAWEntry const &entry, bool inRsrc)
| try to read the PICT unknown entry: pnot:0
bool | readViews (MWAWEntry const &entry, bool inRsrc)
| try to read a list of views : VIEW:1
Protected Member Functions inherited from MWAWGraphicParser
| MWAWGraphicParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWGraphicParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes

std::shared_ptr< MacDraft5StyleManager > | m_styleManager
| the style manager
std::shared_ptr< MacDraft5ParserInternal::State > | m_state
| the state

## Friends

class | MacDraft5StyleManager
class | MacDraft5ParserInternal::SubDocument

## Detailed Description

the main class to read a MacDraft5 v4-v5 file

## Constructor & Destructor Documentation

## MacDraft5Parser()

MacDraft5Parser::MacDraft5Parser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ~MacDraft5Parser()

MacDraft5Parser::~MacDraft5Parser | ( |  | ) |

final

destructor

## Member Function Documentation

## checkHeader()

bool MacDraft5Parser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )

final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by MacDraft5ParserInternal::SubDocument, and parse().

## createDocument()

void MacDraft5Parser::createDocument | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by MacDraft5ParserInternal::SubDocument, and parse().

## createZones()

bool MacDraft5Parser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by MacDraft5ParserInternal::SubDocument, and parse().

## init()

void MacDraft5Parser::init | ( |  | ) |

protected

inits all internal variables

Referenced by MacDraft5Parser(), and MacDraft5ParserInternal::SubDocument.

## parse()

void MacDraft5Parser::parse | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |

final virtual

virtual function used to parse the input

Implements MWAWGraphicParser.

Referenced by MacDraft5ParserInternal::SubDocument.

## readDocFooter()

bool MacDraft5Parser::readDocFooter | ( |  | ) |

protected

try to read last doc zone

Referenced by createZones(), and MacDraft5ParserInternal::SubDocument.

## readDocHeader()

bool MacDraft5Parser::readDocHeader | ( |  | ) |

protected

try to read the doc header zone ( mainly unknown )

Referenced by createZones(), and MacDraft5ParserInternal::SubDocument.

## readLayout()

bool MacDraft5Parser::readLayout | ( | MacDraft5ParserInternal::Layout & | layout | ) |

protected

try to read the layout zone

Referenced by createZones(), and MacDraft5ParserInternal::SubDocument.

## readLayoutDefinitions()

bool MacDraft5Parser::readLayoutDefinitions | ( | MWAWEntry const & | entry,
|  | bool | inRsrc )

protected

try to read a LAYI:0 resource

Referenced by MacDraft5ParserInternal::SubDocument.

## readLibraryFooter()

bool MacDraft5Parser::readLibraryFooter | ( |  | ) |

protected

try to read last library zone

Referenced by createZones(), and MacDraft5ParserInternal::SubDocument.

## readLibraryHeader()

bool MacDraft5Parser::readLibraryHeader | ( |  | ) |

protected

try to read the library header zone ( mainly unknown )

Referenced by createZones(), and MacDraft5ParserInternal::SubDocument.

## readLinks()

bool MacDraft5Parser::readLinks | ( | MWAWEntry const & | entry,
|  | bool | inRsrc )

protected

try to read Link:128 resource

Referenced by MacDraft5ParserInternal::SubDocument.

## readModifier()

bool MacDraft5Parser::readModifier | ( | MacDraft5ParserInternal::Shape & | shape | ) |

protected

try to read a modifier

Referenced by MacDraft5ParserInternal::SubDocument, and readObject().

## readObject()

bool MacDraft5Parser::readObject | ( | MacDraft5ParserInternal::Layout & | layout | ) |

protected

try to read an object

Referenced by MacDraft5ParserInternal::SubDocument, and readLayout().

## readPICT()

bool MacDraft5Parser::readPICT | ( | MWAWEntry const & | entry,
|  | librevenge::RVNGBinaryData & | pict )

protected

try to read a PICT entry (in data fork)

Referenced by MacDraft5ParserInternal::SubDocument.

## readPICTList()

bool MacDraft5Parser::readPICTList | ( | MWAWEntry const & | entry,
|  | bool | inRsrc )

protected

try to read the PICT unknown entry: pnot:0

Referenced by MacDraft5ParserInternal::SubDocument.

## readPrintInfo()

bool MacDraft5Parser::readPrintInfo | ( |  | ) |

protected

try to read the print info zone

Referenced by checkHeader(), and MacDraft5ParserInternal::SubDocument.

## readStringList()

bool MacDraft5Parser::readStringList | ( |  | ) |

protected

try to read a list of strings

Referenced by MacDraft5ParserInternal::SubDocument, and readObject().

## readText()

bool MacDraft5Parser::readText | ( | MacDraft5ParserInternal::Shape & | shape | ) |

protected

try to read the text data corresponding to a text shape

Referenced by MacDraft5ParserInternal::SubDocument, and readObject().

## readViews()

bool MacDraft5Parser::readViews | ( | MWAWEntry const & | entry,
|  | bool | inRsrc )

protected

try to read a list of views : VIEW:1

Referenced by MacDraft5ParserInternal::SubDocument.

## send() [1/3]

bool MacDraft5Parser::send | ( | MacDraft5ParserInternal::Image const & | image | ) |

protected

try to send all shapes in an image

Referenced by MacDraft5ParserInternal::SubDocument, parse(), send(), send(), and send().

## send() [2/3]

bool MacDraft5Parser::send | ( | MacDraft5ParserInternal::Layout const & | layout | ) |

protected

try to send all shapes in an layout

## send() [3/3]

bool MacDraft5Parser::send | ( | MacDraft5ParserInternal::Shape const & | shape,
|  | MacDraft5ParserInternal::Layout const & | layout,
|  | int | depth = 0 )

protected

try to send a shape in a layout

## sendBitmap()

bool MacDraft5Parser::sendBitmap | ( | MacDraft5ParserInternal::Shape const & | bitmap,
|  | MWAWPosition const & | position )

protected

try to send a bitmap

Referenced by MacDraft5ParserInternal::SubDocument, and send().

## sendText()

bool MacDraft5Parser::sendText | ( | int | layoutId,
|  | long | shapeId )

protected

try to send text with given id

Referenced by MacDraft5ParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## MacDraft5ParserInternal::SubDocument

friend class MacDraft5ParserInternal::SubDocument

friend

## MacDraft5StyleManager

friend class MacDraft5StyleManager

friend

Referenced by init(), and MacDraft5StyleManager.

## Member Data Documentation

## m_state

std::shared_ptr<MacDraft5ParserInternal::State> MacDraft5Parser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), MacDraft5Parser(), parse(), readDocHeader(), readLayout(), readLayoutDefinitions(), readLibraryFooter(), send(), send(), and sendText().

## m_styleManager

std::shared_ptr<MacDraft5StyleManager> MacDraft5Parser::m_styleManager

protected

the style manager

Referenced by createZones(), init(), MacDraft5Parser(), readObject(), and sendBitmap().

The documentation for this class was generated from the following files:

- MacDraft5Parser.hxx
- MacDraft5Parser.cxx